##############################################################################
#
# Docker Aliases
#
##############################################################################
if command_exists docker; then

    function all_docker_containers() {
        docker container ls -a | tail -n +2 | awk '{ print $1}'
    }

    function all_docker_images() {
        docker image ls -a | tail -n +2 | awk '{ print $3}'
    }

    function don() {
        docker container ls | grep $1 | awk '{print $1}' | xargs
    }

    alias docker-prune='docker system prune -a'
    alias dco='docker container'
    alias dci='docker image'
    alias dcv='docker volume'
    alias dcn='docker network'
    alias dcl='docker logs'
    alias dost='docker stats --format "table {{.Container}}\t{{.Name}}\t{{.CPUPerc}}\t{{.MemPerc}}\t{{.MemUsage}}\t{{.NetIO}}\t{{.BlockIO}}"'

    function docca () {
        n=$'\n'
        containers=`all_docker_containers`
        if prompt_user "Run on the following containers?: $n$containers$n"; then
            echo $containers | xargs docker container "$@"
        fi

    }

    function doccar () {
        n=$'\n'
        containers=`all_docker_containers`
        if prompt_user "Delete the following containers: $n$containers$n"; then
            echo $containers | xargs docker container rm -f
        fi
    }

    function doi () {
        docker exec -it `don $1` /bin/bash
    }

    function dolo () {
        command="multitail -o beep_method:popup "
        for container in "$@"
        do
            command+="-cT ansi -l 'docker logs -f $container' "
        done
        eval ${command}
    }

fi
