##############################################################################
#
# Wintermute (Personal Server) Commands
#
##############################################################################

# Upload a file to wintermute
function upload() {
  file=`curl -H 'Authorization: Basic cmFtYXRldmlzaDpVcmlhbDk5MQ==' -F "file=@$1"  https://media.matevi.sh/api/upload.php | jq .url | tr -d '"'`
  echo "https://media.matevi.sh/$file"
}

function del-upload() {
    curl -X "DELETE" "https://mtv.sh/files/$1" --header "Authorization:mysecret"
}

function add_alias() {
    curl --header "Content-Type: application/json" \
         --request POST \
         --header "Authorization:mysecret" \
         --data "{\"alias\": \"$1\", \"target\": \"$2\"}" \
         https://mtv.sh/aliases
    echo "http://mtv.sh/a/$1"
}

############ SSHFS

SSHFS_OPTS="auto_cache,reconnect,defer_permissions,noappledouble,nolocalcaches,no_readahead";

# Mount wintermute root
WINTERMUTE_ROOT_MOUNT_DIR="$HOME/wintermute";
function mount-wintermute() {
    umount $WINTERMUTE_ROOT_MOUNT_DIR;
    mkdir -p $WINTERMUTE_ROOT_MOUNT_DIR && sshfs matevi.sh:/ $WINTERMUTE_ROOT_MOUNT_DIR -o$SSHFS_OPTS -ovolname=wintermute-root;
}
function umount-wintermute() {
    umount $WINTERMUTE_ROOT_MOUNT_DIR && rmdir $WINTERMUTE_ROOT_MOUNT_DIR;
}

alias wd='docker -H=localhost:2376'

function tun_docker() {
    ssh -nNT -L 2376:localhost:2375 wintermute &
    PID=$!
    $SHELL
    kill $PID
}

function tun_publish()
{
    ssh -nNT -R 9001:localhost:${1:-8000} wintermute
}

function tun_publish_dir()
{
    python3 -m http.server &
    PID=$!
    tun_publish 8000
    kill $PID
}

function tun_tcp()
{
    ssh -nNT -R ${2:-2299}:localhost:$1 wintermute
}

function white-led () {
    ssh dixie "nohup watch -n 10 \"echo '2' > /proc/gpio/led_pattern\" &"
}
